// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             (unknown)
// source: proto/fastdata.proto

package proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// HeroServiceClient is the client API for HeroService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type HeroServiceClient interface {
	GetID(ctx context.Context, in *StringValue, opts ...grpc.CallOption) (*ByteSlice, error)
	// rpc GetID(StringValue) returns (JsonResponse) {}
	// rpc GetID(StringValue) returns (Hero) {}
	GetName(ctx context.Context, in *StringValue, opts ...grpc.CallOption) (*ByteSlice, error)
	GetNameList(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ByteSlice, error)
}

type heroServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewHeroServiceClient(cc grpc.ClientConnInterface) HeroServiceClient {
	return &heroServiceClient{cc}
}

func (c *heroServiceClient) GetID(ctx context.Context, in *StringValue, opts ...grpc.CallOption) (*ByteSlice, error) {
	out := new(ByteSlice)
	err := c.cc.Invoke(ctx, "/proto.HeroService/GetID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *heroServiceClient) GetName(ctx context.Context, in *StringValue, opts ...grpc.CallOption) (*ByteSlice, error) {
	out := new(ByteSlice)
	err := c.cc.Invoke(ctx, "/proto.HeroService/GetName", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *heroServiceClient) GetNameList(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ByteSlice, error) {
	out := new(ByteSlice)
	err := c.cc.Invoke(ctx, "/proto.HeroService/GetNameList", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// HeroServiceServer is the server API for HeroService service.
// All implementations must embed UnimplementedHeroServiceServer
// for forward compatibility
type HeroServiceServer interface {
	GetID(context.Context, *StringValue) (*ByteSlice, error)
	// rpc GetID(StringValue) returns (JsonResponse) {}
	// rpc GetID(StringValue) returns (Hero) {}
	GetName(context.Context, *StringValue) (*ByteSlice, error)
	GetNameList(context.Context, *emptypb.Empty) (*ByteSlice, error)
	mustEmbedUnimplementedHeroServiceServer()
}

// UnimplementedHeroServiceServer must be embedded to have forward compatible implementations.
type UnimplementedHeroServiceServer struct {
}

func (UnimplementedHeroServiceServer) GetID(context.Context, *StringValue) (*ByteSlice, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetID not implemented")
}
func (UnimplementedHeroServiceServer) GetName(context.Context, *StringValue) (*ByteSlice, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetName not implemented")
}
func (UnimplementedHeroServiceServer) GetNameList(context.Context, *emptypb.Empty) (*ByteSlice, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetNameList not implemented")
}
func (UnimplementedHeroServiceServer) mustEmbedUnimplementedHeroServiceServer() {}

// UnsafeHeroServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to HeroServiceServer will
// result in compilation errors.
type UnsafeHeroServiceServer interface {
	mustEmbedUnimplementedHeroServiceServer()
}

func RegisterHeroServiceServer(s grpc.ServiceRegistrar, srv HeroServiceServer) {
	s.RegisterService(&HeroService_ServiceDesc, srv)
}

func _HeroService_GetID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StringValue)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HeroServiceServer).GetID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.HeroService/GetID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HeroServiceServer).GetID(ctx, req.(*StringValue))
	}
	return interceptor(ctx, in, info, handler)
}

func _HeroService_GetName_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StringValue)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HeroServiceServer).GetName(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.HeroService/GetName",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HeroServiceServer).GetName(ctx, req.(*StringValue))
	}
	return interceptor(ctx, in, info, handler)
}

func _HeroService_GetNameList_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HeroServiceServer).GetNameList(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.HeroService/GetNameList",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HeroServiceServer).GetNameList(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// HeroService_ServiceDesc is the grpc.ServiceDesc for HeroService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var HeroService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "proto.HeroService",
	HandlerType: (*HeroServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetID",
			Handler:    _HeroService_GetID_Handler,
		},
		{
			MethodName: "GetName",
			Handler:    _HeroService_GetName_Handler,
		},
		{
			MethodName: "GetNameList",
			Handler:    _HeroService_GetNameList_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/fastdata.proto",
}
